USE WORK.arq_pack.ALL;

ENTITY alu_4bits IS
GENERIC	(retardo:TIME:=25 ns);
PORT	(a, b:IN BIT_VECTOR (3 DOWNTO 0);
	op:IN BIT_VECTOR(1 DOWNTO 0);
	modo, cn:IN BIT;
	resultado:OUT vector_bus;
	cns, igual:OUT BIT);
END alu_4bits;

ARCHITECTURE comportamental OF alu_4bits IS
BEGIN
	PROCESS(a, b, op, modo, cn)
	VARIABLE op_a, op_b:BIT_VECTOR (3 DOWNTO 0);
	VARIABLE seleccion:BIT_VECTOR (1 DOWNTO 0);
	VARIABLE operacion:INTEGER;
	VARIABLE salida:BIT_VECTOR (3 DOWNTO 0);
	VARIABLE aux1, aux2, aux3:INTEGER;
	BEGIN
  
	--asociamos las entradas a variables ya que los procedimientos solo trabajan con variables y convertimos de tipo vector_bus (tri-estado) a bit_vector (estado '0' o '1')

	FOR i IN 0 TO 3 LOOP
		IF a(i) = '0' THEN op_a(i) := '0';
		ELSE op_a(i) := '1';
		END IF;
		IF b(i) = '0' THEN op_b(i) := '0';
		ELSE op_b(i) := '1';
		END IF;
	END LOOP;

	seleccion:=op;

	logico_entero(seleccion, operacion);

	--operaciones lgicas
	IF (modo='1') THEN
		cns <='0' AFTER retardo;
		igual <='0' AFTER retardo;
		CASE operacion IS

		WHEN 0=>salida:=op_a OR op_b;
		WHEN 1=>salida:=op_a AND op_b;
		WHEN 2=>salida:=op_a XOR op_b;
		WHEN 3=>salida:=NOT op_a;
		WHEN OTHERS=>NULL;
		END CASE;

	--operaciones aritmticas
	ELSE
		CASE operacion IS
		WHEN 0=>salida:=a;
		cns <='0' AFTER retardo;
		igual <='0' AFTER retardo;

		WHEN 1=>salida:=b;
		cns <='0' AFTER retardo;
		igual <='0' AFTER retardo;

		--suma
		WHEN 2=>
		logico_entero(op_a, aux1);
		logico_entero(op_b, aux2);
		aux3:= aux1 + aux2;
		IF cn = '1' THEN aux3:= aux3 + 1; END IF;
		IF aux3 > 15 THEN
			aux3:= aux3 - 16;
			cns <='1' AFTER retardo;
		ELSE cns <='0' AFTER retardo;
		END IF;
		entero_logico (aux3, salida);

		--resta
		WHEN 3=>
		logico_entero(op_a, aux1);
		logico_entero(op_b, aux2);
		--complemento a 1 del operando B
		aux2:= 15 - aux2;
		aux3:=aux1 + aux2;
		IF cn = '1' THEN aux3:= aux3 + 1; END IF;
		IF aux3 > 15 THEN
			aux3:= aux3 - 16;
			cns <='1' AFTER retardo;
		ELSE cns <='0' AFTER retardo;
		END IF;
		IF aux3 = 0 THEN igual <='1' AFTER retardo;
		ELSE igual <='0' AFTER retardo;
		END IF;
		entero_logico(aux3, salida);
		WHEN OTHERS=>NULL;
		END CASE;

	END IF;

	FOR i IN 0 TO 3 LOOP
		IF salida(i) = '0' THEN resultado(i)<='0' AFTER retardo;
		ELSE resultado(i)<='1' AFTER retardo;
		END IF;
	END LOOP;

	END PROCESS;
END comportamental;




