--modelo de la memoria RAM 7489

USE WORK.arq_pack.ALL;
--se incluye el paquete ram_pack (procedimiento de conversin de lgico a entero, tipos y seal resuelta)

ENTITY ram_7489 IS
	--retardo_salida: retardo de propagacin de las celdas de memoria a la salida
	--retardo_Z: retardo de propagacin del estado Z a la salida
	GENERIC(retardo_salida:TIME:=300 ns; retardo_Z:TIME:=300 ns);
	PORT(DATA_IN:IN BIT_VECTOR(3 DOWNTO 0):=X"0";
	ADDRESS:IN BIT_VECTOR(3 DOWNTO 0):=X"0";
	ME,WE:IN BIT:='0';
	DATA_OUT:OUT vector_bus:=('Z','Z','Z','Z'));
END ram_7489;

ARCHITECTURE comportamiento OF ram_7489 IS
BEGIN
	PROCESS
	-------------------------------------------------------------
	--declaracion de tipos y variables

	TYPE memoria IS ARRAY(15 DOWNTO 0) OF BIT_VECTOR(3 DOWNTO 0);
	VARIABLE palabra:memoria;
	VARIABLE comienzo:BOOLEAN:=true;
	VARIABLE dir_logica:BIT_VECTOR (3 DOWNTO 0);
	VARIABLE dir_entero:INTEGER;
	-------------------------------------------------------------
	--comienza el proceso
	--se despierta con cambios en ADDRESS, DATA_IN, ME y WE

	BEGIN
	WAIT ON ADDRESS, DATA_IN, ME, WE;
	-------------------------------------------------------------
	--inicialmente todas las posiciones de la memoria estan a '0'

	IF comienzo THEN
		FOR i IN palabra'RANGE LOOP
		palabra(i):=('0','0','0','0');
		END LOOP;
		comienzo:=false;
	END IF;
	-------------------------------------------------------------           -------------------------------------------------------------
	--chip de memoria activo

	IF (ME='0') THEN        --la memoria est activada
	-------------------------------------------------------------
	--se lee la direccin
	--(no hay retardo en direccionar las celdas de memoria)

		dir_logica:=ADDRESS;    
		logico_entero(dir_logica, dir_entero);
		--se convierte el valor lgico de la direccin a entero
		--se usa el procedimiento declarado en el paquete ram_pack
	-------------------------------------------------------------

		IF (WE='1') THEN        --comienza el ciclo de lectura
		FOR i IN 0 TO 3 LOOP
			IF palabra(dir_entero)(i)='0'THEN 
			DATA_OUT(i)<=TRANSPORT'0'AFTER retardo_salida;
			ELSE DATA_OUT(i)<=TRANSPORT'1'AFTER retardo_salida;
			END IF;
		END LOOP;
	-------------------------------------------------------------

		ELSE                    --comienza el ciclo de escritura
		palabra(dir_entero):=DATA_IN;

		--(no hay retardo en escribir en las celdas)
	-------------------------------------------------------------
		--la salida permanece en estado de alta impedancia

		FOR i IN 0 TO 3 LOOP
			DATA_OUT(i)<=TRANSPORT 'Z' AFTER retardo_Z;
			--propagacin de WE al estado Z (300 ns) 
		END LOOP;
		END IF;
	-------------------------------------------------------------           -------------------------------------------------------------
	--chip de memoria inactivo

	ELSE            --la memoria no est activada

		FOR i IN 0 TO 3 LOOP
			DATA_OUT(i)<=TRANSPORT 'Z' AFTER retardo_Z;
			--propagacin de ME al estado Z (300 ns) 
		END LOOP;
	END IF;
	-------------------------------------------------------------
	END PROCESS;
END comportamiento;
    



 


